#define MD5LEN 16
#define HASHKEYLEN 16
#include <sys/md5.h>

typedef struct hash_entry {
  struct hash_entry *next;
  int id;
  int keylen;
  char key[HASHKEYLEN];
} HASH_ENTRY;
typedef struct hash_db {
  int hdb_size;			/* size of db */
  int hdb_index;		/* unique entries */
  int hdb_cols;			/* count collisions */
  int hdb_thres100;		/* threshold % */
  char *hdb_name;		/* name for diagnostics */
  HASH_ENTRY *hdb_array;
  MD5_CTX hdb_md5ctx;
} HASH_DB;

#define HASH_RESCALE 2
#define HASH_TRESH_SCALE 100
#define HASH_TRESH_10p (HASH_TRESH_SCALE/10)
#define HASH_TRESH_50p (HASH_TRESH_SCALE/2)
#define HASH_TRESH_100p HASH_TRESH_SCALE

int hash_get_id (HASH_DB *hash_db, const char *key,  int keylen);
int hash_put(HASH_DB *hash_db, const char *key,  int keylen);
int hash_put_print (HASH_DB *hash_db, const char *key,  int keylen);
void hash_stat(HASH_DB *hash_db);
HASH_DB *hash_create(char *name, int size, int thres100);
HASH_DB *mkhash(char **strs, char *name, int hash_size, int thres100);
void hash_print (HASH_DB *hash_db);
